"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classnames = _interopRequireDefault(require("classnames"));

var _isEqual = _interopRequireDefault(require("lodash/isEqual"));

var _nanoid = _interopRequireDefault(require("nanoid"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _Button = _interopRequireDefault(require("./Button"));

var _NodeModel = _interopRequireDefault(require("./NodeModel"));

var _TreeNode = _interopRequireDefault(require("./TreeNode"));

var _iconsShape = _interopRequireDefault(require("./shapes/iconsShape"));

var _languageShape = _interopRequireDefault(require("./shapes/languageShape"));

var _listShape = _interopRequireDefault(require("./shapes/listShape"));

var _nodeShape = _interopRequireDefault(require("./shapes/nodeShape"));

var CheckboxTree =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(CheckboxTree, _React$Component);

  function CheckboxTree(props) {
    var _this;

    (0, _classCallCheck2.default)(this, CheckboxTree);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(CheckboxTree).call(this, props));
    var model = new _NodeModel.default(props);
    model.flattenNodes(props.nodes);
    model.deserializeLists({
      checked: props.checked,
      expanded: props.expanded
    });
    _this.state = {
      id: props.id || "rct-".concat((0, _nanoid.default)(7)),
      model: model,
      prevProps: props
    };
    _this.onCheck = _this.onCheck.bind((0, _assertThisInitialized2.default)(_this));
    _this.onExpand = _this.onExpand.bind((0, _assertThisInitialized2.default)(_this));
    _this.onNodeClick = _this.onNodeClick.bind((0, _assertThisInitialized2.default)(_this));
    _this.onExpandAll = _this.onExpandAll.bind((0, _assertThisInitialized2.default)(_this));
    _this.onCollapseAll = _this.onCollapseAll.bind((0, _assertThisInitialized2.default)(_this));
    return _this;
  } // eslint-disable-next-line react/sort-comp


  (0, _createClass2.default)(CheckboxTree, [{
    key: "onCheck",
    value: function onCheck(nodeInfo) {
      var _this$props = this.props,
          noCascade = _this$props.noCascade,
          onCheck = _this$props.onCheck;
      var model = this.state.model.clone();
      var node = model.getNode(nodeInfo.value);
      model.toggleChecked(nodeInfo, nodeInfo.checked, noCascade);
      onCheck(model.serializeList('checked'), (0, _objectSpread2.default)({}, node, nodeInfo));
    }
  }, {
    key: "onExpand",
    value: function onExpand(nodeInfo) {
      var onExpand = this.props.onExpand;
      var model = this.state.model.clone();
      var node = model.getNode(nodeInfo.value);
      model.toggleNode(nodeInfo.value, 'expanded', nodeInfo.expanded);
      onExpand(model.serializeList('expanded'), (0, _objectSpread2.default)({}, node, nodeInfo));
    }
  }, {
    key: "onNodeClick",
    value: function onNodeClick(nodeInfo) {
      var onClick = this.props.onClick;
      var model = this.state.model;
      var node = model.getNode(nodeInfo.value);
      onClick((0, _objectSpread2.default)({}, node, nodeInfo));
    }
  }, {
    key: "onExpandAll",
    value: function onExpandAll() {
      this.expandAllNodes();
    }
  }, {
    key: "onCollapseAll",
    value: function onCollapseAll() {
      this.expandAllNodes(false);
    }
  }, {
    key: "expandAllNodes",
    value: function expandAllNodes() {
      var expand = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
      var onExpand = this.props.onExpand;
      onExpand(this.state.model.clone().expandAllNodes(expand).serializeList('expanded'));
    }
  }, {
    key: "determineShallowCheckState",
    value: function determineShallowCheckState(node, noCascade) {
      var flatNode = this.state.model.getNode(node.value);

      if (flatNode.isLeaf || noCascade) {
        return flatNode.checked ? 1 : 0;
      }

      if (this.isEveryChildChecked(node)) {
        return 1;
      }

      if (this.isSomeChildChecked(node)) {
        return 2;
      }

      return 0;
    }
  }, {
    key: "isEveryChildChecked",
    value: function isEveryChildChecked(node) {
      var _this2 = this;

      return node.children.every(function (child) {
        return _this2.state.model.getNode(child.value).checkState === 1;
      });
    }
  }, {
    key: "isSomeChildChecked",
    value: function isSomeChildChecked(node) {
      var _this3 = this;

      return node.children.some(function (child) {
        return _this3.state.model.getNode(child.value).checkState > 0;
      });
    }
  }, {
    key: "renderTreeNodes",
    value: function renderTreeNodes(nodes) {
      var _this4 = this;

      var parent = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var _this$props2 = this.props,
          expandDisabled = _this$props2.expandDisabled,
          expandOnClick = _this$props2.expandOnClick,
          icons = _this$props2.icons,
          lang = _this$props2.lang,
          noCascade = _this$props2.noCascade,
          onClick = _this$props2.onClick,
          onlyLeafCheckboxes = _this$props2.onlyLeafCheckboxes,
          optimisticToggle = _this$props2.optimisticToggle,
          showNodeTitle = _this$props2.showNodeTitle,
          showNodeIcon = _this$props2.showNodeIcon;
      var _this$state = this.state,
          id = _this$state.id,
          model = _this$state.model;
      var defaultIcons = CheckboxTree.defaultProps.icons;
      var treeNodes = nodes.map(function (node) {
        var key = node.value;
        var flatNode = model.getNode(node.value);
        var children = flatNode.isParent ? _this4.renderTreeNodes(node.children, node) : null; // Determine the check state after all children check states have been determined
        // This is done during rendering as to avoid an additional loop during the
        // deserialization of the `checked` property

        flatNode.checkState = _this4.determineShallowCheckState(node, noCascade); // Show checkbox only if this is a leaf node or showCheckbox is true

        var showCheckbox = onlyLeafCheckboxes ? flatNode.isLeaf : flatNode.showCheckbox; // console.log(onlyLeafCheckboxes);
        // const showCheckbox = false;
        // Render only if parent is expanded or if there is no root parent

        var parentExpanded = parent.value ? model.getNode(parent.value).expanded : true;

        if (!parentExpanded) {
          return null;
        }

        return _react.default.createElement(_TreeNode.default, {
          key: key,
          checked: flatNode.checkState,
          className: node.className,
          disabled: flatNode.disabled,
          expandDisabled: expandDisabled,
          expandOnClick: expandOnClick,
          expanded: flatNode.expanded,
          icon: node.icon,
          icons: (0, _objectSpread2.default)({}, defaultIcons, icons),
          label: node.label,
          lang: lang,
          optimisticToggle: optimisticToggle,
          isLeaf: flatNode.isLeaf,
          isParent: flatNode.isParent,
          showCheckbox: showCheckbox,
          showIcon: node.showIcon,
          showNodeIcon: showNodeIcon,
          title: showNodeTitle ? node.title || node.label : node.title,
          category: node.category,
          treeId: id,
          value: node.value,
          onCheck: _this4.onCheck,
          onClick: onClick && _this4.onNodeClick,
          onExpand: _this4.onExpand
        }, children);
      });
      return _react.default.createElement("ol", null, treeNodes);
    }
  }, {
    key: "renderExpandAll",
    value: function renderExpandAll() {
      var _this$props3 = this.props,
          _this$props3$icons = _this$props3.icons,
          expandAll = _this$props3$icons.expandAll,
          collapseAll = _this$props3$icons.collapseAll,
          lang = _this$props3.lang,
          showExpandAll = _this$props3.showExpandAll;

      if (!showExpandAll) {
        return null;
      }

      return _react.default.createElement("div", {
        className: "rct-options"
      }, _react.default.createElement(_Button.default, {
        className: "rct-option rct-option-expand-all",
        title: lang.expandAll,
        onClick: this.onExpandAll
      }, expandAll), _react.default.createElement(_Button.default, {
        className: "rct-option rct-option-collapse-all",
        title: lang.collapseAll,
        onClick: this.onCollapseAll
      }, collapseAll));
    }
  }, {
    key: "renderHiddenInput",
    value: function renderHiddenInput() {
      var _this$props4 = this.props,
          name = _this$props4.name,
          nameAsArray = _this$props4.nameAsArray;

      if (name === undefined) {
        return null;
      }

      if (nameAsArray) {
        return this.renderArrayHiddenInput();
      }

      return this.renderJoinedHiddenInput();
    }
  }, {
    key: "renderArrayHiddenInput",
    value: function renderArrayHiddenInput() {
      var _this$props5 = this.props,
          checked = _this$props5.checked,
          inputName = _this$props5.name;
      return checked.map(function (value) {
        var name = "".concat(inputName, "[]");
        return _react.default.createElement("input", {
          key: value,
          name: name,
          type: "hidden",
          value: value
        });
      });
    }
  }, {
    key: "renderJoinedHiddenInput",
    value: function renderJoinedHiddenInput() {
      var _this$props6 = this.props,
          checked = _this$props6.checked,
          name = _this$props6.name;
      var inputValue = checked.join(',');
      return _react.default.createElement("input", {
        name: name,
        type: "hidden",
        value: inputValue
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props7 = this.props,
          disabled = _this$props7.disabled,
          nodes = _this$props7.nodes,
          nativeCheckboxes = _this$props7.nativeCheckboxes;
      var treeNodes = this.renderTreeNodes(nodes);
      var className = (0, _classnames.default)({
        'newton-checkbox-tree': true,
        'rct-disabled': disabled,
        'rct-native-display': nativeCheckboxes
      });
      return _react.default.createElement("div", {
        className: className
      }, this.renderExpandAll(), this.renderHiddenInput(), treeNodes);
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(newProps, prevState) {
      var model = prevState.model,
          prevProps = prevState.prevProps;
      var disabled = newProps.disabled,
          id = newProps.id,
          nodes = newProps.nodes;
      var newState = (0, _objectSpread2.default)({}, prevState, {
        prevProps: newProps
      }); // Apply new properties to model

      model.setProps(newProps); // Since flattening nodes is an expensive task, only update when there is a node change

      if (!(0, _isEqual.default)(prevProps.nodes, nodes) || prevProps.disabled !== disabled) {
        model.flattenNodes(nodes);
      }

      if (id !== null) {
        newState = (0, _objectSpread2.default)({}, newState, {
          id: id
        });
      }

      model.deserializeLists({
        checked: newProps.checked,
        expanded: newProps.expanded
      });
      return newState;
    }
  }]);
  return CheckboxTree;
}(_react.default.Component);

(0, _defineProperty2.default)(CheckboxTree, "defaultProps", {
  checked: [],
  disabled: false,
  expandDisabled: false,
  expandOnClick: false,
  expanded: [],
  icons: {
    check: _react.default.createElement("span", {
      className: "rct-icon rct-icon-check"
    }),
    uncheck: _react.default.createElement("span", {
      className: "rct-icon rct-icon-uncheck"
    }),
    halfCheck: _react.default.createElement("span", {
      className: "rct-icon rct-icon-half-check"
    }),
    expandClose: _react.default.createElement("span", {
      className: "rct-icon rct-icon-expand-close"
    }),
    expandOpen: _react.default.createElement("span", {
      className: "rct-icon rct-icon-expand-open"
    }),
    expandAll: _react.default.createElement("span", {
      className: "rct-icon rct-icon-expand-all"
    }),
    collapseAll: _react.default.createElement("span", {
      className: "rct-icon rct-icon-collapse-all"
    }),
    parentClose: _react.default.createElement("span", {
      className: "rct-icon rct-icon-parent-close"
    }),
    parentOpen: _react.default.createElement("span", {
      className: "rct-icon rct-icon-parent-open"
    }),
    leaf: _react.default.createElement("span", {
      className: "rct-icon rct-icon-leaf"
    })
  },
  id: null,
  lang: {
    collapseAll: 'Collapse all',
    expandAll: 'Expand all',
    toggle: 'Toggle'
  },
  name: undefined,
  nameAsArray: false,
  nativeCheckboxes: false,
  noCascade: false,
  onlyLeafCheckboxes: false,
  optimisticToggle: true,
  showExpandAll: false,
  showNodeIcon: true,
  showNodeTitle: false,
  onCheck: function onCheck() {},
  onClick: null,
  onExpand: function onExpand() {}
});
CheckboxTree.propTypes = process.env.NODE_ENV !== "production" ? {
  checked: _listShape.default,
  disabled: _propTypes.default.bool,
  expandDisabled: _propTypes.default.bool,
  expanded: _listShape.default,
  expandOnClick: _propTypes.default.bool,
  icons: _iconsShape.default,
  id: _propTypes.default.string,
  lang: _languageShape.default,
  name: _propTypes.default.string,
  nameAsArray: _propTypes.default.bool,
  nativeCheckboxes: _propTypes.default.bool,
  noCascade: _propTypes.default.bool,
  nodes: _propTypes.default.arrayOf(_nodeShape.default).isRequired,
  onCheck: _propTypes.default.func,
  onClick: _propTypes.default.func,
  onExpand: _propTypes.default.func,
  onlyLeafCheckboxes: _propTypes.default.bool,
  optimisticToggle: _propTypes.default.bool,
  showExpandAll: _propTypes.default.bool,
  showNodeIcon: _propTypes.default.bool,
  showNodeTitle: _propTypes.default.bool
} : {};
var _default = CheckboxTree; // export { CheckboxTree };

exports.default = _default;