"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _Button = _interopRequireDefault(require("./Button"));

var _NativeCheckbox = _interopRequireDefault(require("./NativeCheckbox"));

var _iconsShape = _interopRequireDefault(require("./shapes/iconsShape"));

var _languageShape = _interopRequireDefault(require("./shapes/languageShape"));

var TreeNode =
/*#__PURE__*/
function (_React$Component) {
  (0, _inherits2.default)(TreeNode, _React$Component);

  function TreeNode(props) {
    var _this;

    (0, _classCallCheck2.default)(this, TreeNode);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(TreeNode).call(this, props));
    _this.onCheck = _this.onCheck.bind((0, _assertThisInitialized2.default)(_this));
    _this.onClick = _this.onClick.bind((0, _assertThisInitialized2.default)(_this));
    _this.onExpand = _this.onExpand.bind((0, _assertThisInitialized2.default)(_this));
    return _this;
  }

  (0, _createClass2.default)(TreeNode, [{
    key: "onCheck",
    value: function onCheck() {
      var _this$props = this.props,
          value = _this$props.value,
          onCheck = _this$props.onCheck;
      onCheck({
        value: value,
        checked: this.getCheckState({
          toggle: true
        })
      });
    }
  }, {
    key: "onClick",
    value: function onClick() {
      var _this$props2 = this.props,
          expandOnClick = _this$props2.expandOnClick,
          isParent = _this$props2.isParent,
          value = _this$props2.value,
          onClick = _this$props2.onClick; // Auto expand if enabled

      if (isParent && expandOnClick) {
        this.onExpand();
      }

      onClick({
        value: value,
        checked: this.getCheckState({
          toggle: false
        })
      });
    }
  }, {
    key: "onExpand",
    value: function onExpand() {
      var _this$props3 = this.props,
          expanded = _this$props3.expanded,
          value = _this$props3.value,
          onExpand = _this$props3.onExpand;
      onExpand({
        value: value,
        expanded: !expanded
      });
    }
  }, {
    key: "getCheckState",
    value: function getCheckState(_ref) {
      var toggle = _ref.toggle;
      var _this$props4 = this.props,
          checked = _this$props4.checked,
          optimisticToggle = _this$props4.optimisticToggle; // Toggle off state to checked

      if (checked === 0 && toggle) {
        return true;
      } // Node is already checked and we are not toggling


      if (checked === 1 && !toggle) {
        return true;
      } // Get/toggle partial state based on cascade model


      if (checked === 2) {
        return optimisticToggle;
      }

      return false;
    }
  }, {
    key: "renderCollapseButton",
    value: function renderCollapseButton() {
      var _this$props5 = this.props,
          expandDisabled = _this$props5.expandDisabled,
          isLeaf = _this$props5.isLeaf,
          lang = _this$props5.lang;

      if (isLeaf) {
        return _react.default.createElement("span", {
          className: "rct-collapse"
        }, _react.default.createElement("span", {
          className: "rct-icon"
        }));
      }

      return _react.default.createElement(_Button.default, {
        className: "rct-collapse rct-collapse-btn",
        disabled: expandDisabled,
        title: lang.toggle,
        onClick: this.onExpand
      }, this.renderCollapseIcon());
    }
  }, {
    key: "renderCollapseIcon",
    value: function renderCollapseIcon() {
      var _this$props6 = this.props,
          expanded = _this$props6.expanded,
          _this$props6$icons = _this$props6.icons,
          expandClose = _this$props6$icons.expandClose,
          expandOpen = _this$props6$icons.expandOpen;

      if (!expanded) {
        return expandClose;
      }

      return expandOpen;
    }
  }, {
    key: "renderCheckboxIcon",
    value: function renderCheckboxIcon() {
      var _this$props7 = this.props,
          checked = _this$props7.checked,
          _this$props7$icons = _this$props7.icons,
          uncheck = _this$props7$icons.uncheck,
          check = _this$props7$icons.check,
          halfCheck = _this$props7$icons.halfCheck;

      if (checked === 0) {
        return uncheck;
      }

      if (checked === 1) {
        return check;
      }

      return halfCheck;
    }
  }, {
    key: "renderNodeIcon",
    value: function renderNodeIcon() {
      var _this$props8 = this.props,
          expanded = _this$props8.expanded,
          icon = _this$props8.icon,
          _this$props8$icons = _this$props8.icons,
          leaf = _this$props8$icons.leaf,
          parentClose = _this$props8$icons.parentClose,
          parentOpen = _this$props8$icons.parentOpen,
          isLeaf = _this$props8.isLeaf;

      if (icon !== null) {
        return icon;
      }

      if (isLeaf) {
        return leaf;
      }

      if (!expanded) {
        return parentClose;
      }

      return parentOpen;
    }
  }, {
    key: "renderBareLabel",
    value: function renderBareLabel(children) {
      var _this$props9 = this.props,
          onClick = _this$props9.onClick,
          title = _this$props9.title;
      var clickable = onClick !== null;
      return _react.default.createElement("span", {
        className: "rct-bare-label",
        title: title
      }, clickable ? _react.default.createElement("span", {
        className: "rct-node-clickable",
        onClick: this.onClick,
        onKeyPress: this.onClick,
        role: "button",
        tabIndex: 0
      }, children) : children);
    }
  }, {
    key: "renderCheckboxLabel",
    value: function renderCheckboxLabel(children) {
      var _this$props10 = this.props,
          checked = _this$props10.checked,
          disabled = _this$props10.disabled,
          title = _this$props10.title,
          treeId = _this$props10.treeId,
          value = _this$props10.value,
          onClick = _this$props10.onClick;
      var clickable = onClick !== null;
      var inputId = "".concat(treeId, "-").concat(String(value).split(' ').join('_'));
      var render = [_react.default.createElement("label", {
        key: 0,
        htmlFor: inputId,
        title: title
      }, _react.default.createElement(_NativeCheckbox.default, {
        checked: checked === 1,
        disabled: disabled,
        id: inputId,
        indeterminate: checked === 2,
        onClick: this.onCheck,
        onChange: function onChange() {}
      }), _react.default.createElement("span", {
        className: "rct-checkbox"
      }, this.renderCheckboxIcon()), !clickable ? children : null)];

      if (clickable) {
        render.push(_react.default.createElement("span", {
          key: 1,
          className: "rct-node-clickable",
          onClick: this.onClick,
          onKeyPress: this.onClick,
          role: "link",
          tabIndex: 0
        }, children));
      }

      return render;
    }
  }, {
    key: "renderLabel",
    value: function renderLabel() {
      var _this$props11 = this.props,
          label = _this$props11.label,
          category = _this$props11.category,
          showCheckbox = _this$props11.showCheckbox,
          showIcon = _this$props11.showIcon,
          showNodeIcon = _this$props11.showNodeIcon;
      var labelChildren = [showNodeIcon && showIcon ? _react.default.createElement("span", {
        key: 0,
        className: "rct-node-icon"
      }, this.renderNodeIcon()) : null, _react.default.createElement("span", {
        key: 1,
        className: "rct-title"
      }, label, category ? _react.default.createElement("label", {
        className: "rct-category"
      }, category) : "")];

      if (!showCheckbox) {
        return this.renderBareLabel(labelChildren);
      }

      return this.renderCheckboxLabel(labelChildren);
    }
  }, {
    key: "renderChildren",
    value: function renderChildren() {
      if (!this.props.expanded) {
        return null;
      }

      return this.props.children;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props12 = this.props,
          className = _this$props12.className,
          disabled = _this$props12.disabled,
          expanded = _this$props12.expanded,
          isLeaf = _this$props12.isLeaf;
      var nodeClass = (0, _classnames.default)({
        'rct-node': true,
        'rct-node-leaf': isLeaf,
        'rct-node-parent': !isLeaf,
        'rct-node-expanded': !isLeaf && expanded,
        'rct-node-collapsed': !isLeaf && !expanded,
        'rct-disabled': disabled
      }, className);
      return _react.default.createElement("li", {
        className: nodeClass
      }, _react.default.createElement("span", {
        className: "rct-text"
      }, this.renderCollapseButton(), this.renderLabel()), this.renderChildren());
    }
  }]);
  return TreeNode;
}(_react.default.Component);

(0, _defineProperty2.default)(TreeNode, "defaultProps", {
  children: null,
  className: null,
  expandOnClick: false,
  icon: null,
  showCheckbox: true,
  showIcon: true,
  title: null,
  category: null,
  onClick: function onClick() {}
});
TreeNode.propTypes = process.env.NODE_ENV !== "production" ? {
  checked: _propTypes.default.number.isRequired,
  disabled: _propTypes.default.bool.isRequired,
  expandDisabled: _propTypes.default.bool.isRequired,
  expanded: _propTypes.default.bool.isRequired,
  icons: _iconsShape.default.isRequired,
  isLeaf: _propTypes.default.bool.isRequired,
  isParent: _propTypes.default.bool.isRequired,
  label: _propTypes.default.node.isRequired,
  lang: _languageShape.default.isRequired,
  optimisticToggle: _propTypes.default.bool.isRequired,
  showNodeIcon: _propTypes.default.bool.isRequired,
  treeId: _propTypes.default.string.isRequired,
  value: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]).isRequired,
  onCheck: _propTypes.default.func.isRequired,
  onExpand: _propTypes.default.func.isRequired,
  children: _propTypes.default.node,
  className: _propTypes.default.string,
  expandOnClick: _propTypes.default.bool,
  icon: _propTypes.default.node,
  showCheckbox: _propTypes.default.bool,
  showIcon: _propTypes.default.bool,
  title: _propTypes.default.string,
  category: _propTypes.default.string,
  onClick: _propTypes.default.func
} : {};
var _default = TreeNode;
exports.default = _default;